#####################################################################################################################
# Copyright IBM
#
# This PERL script was created by Stuart Poulin of Rational Software 2008.
#
#######################################################################################################################
# Wrapper class to ClearQuest Get
# The Idea is to simplify creating and updating records for ALM 
# IBM Corporation September 29th, 2008
# Stuart Poulin
# 
# my ($act) = $bl->get("Activities");
#
#
# Given a record and a pvob (without slashes) search CQ for the record.
# use get("field") to get the values
# It will return an array;
# my ($act) = $bl->get("Activities");
#
package get_record_details;
our $VERSION = 2008.1002;
 
#
# $self{RECORD_TYPE}->"ALMBaseline"
#
# type="record_type" i.e. ALMBaseline,  ALMTask, Activity,
# pvob=>"pvob_name"
# baseline=>"baselinename"
# id="record id"
sub new { 
	#TODO Test parameters for typos
	my $class = shift;
	my $self = {@_};
	bless($self, $class);
	my $results = $self->get_record_details(@_);
	return $self if $results;
	return undef;
}

sub get_record_details {
	my $self = shift;
	my %lopts = @_;
	my $queryDef = $lopts{session}->BuildQuery($lopts{type});
	# TODO figure out how to do real "top" top=>1

	# Get all the columns for now.
	#my $failure = $queryDef->BuildField("Name");
	my $entdef = $lopts{session}->GetEntityDef($lopts{type});
	my $names = $entdef->GetFieldDefNames();
	
	for my $name (@$names ) {
	   my $failure = $queryDef->BuildField($name);
	}

	my $operator = $queryDef->CreateTopNode($CQPerlExt::CQ_BOOL_OP_AND); 
	$operator->BuildFilter("record_type", $CQPerlExt::CQ_COMP_OP_EQ, ["$lopts{type}"]);

	for my $field_name ( keys %{$self->{fields}} ) {
		my $field_value = $self->{fields}->{$field_name};
		$operator->BuildFilter($field_name, $CQPerlExt::CQ_COMP_OP_EQ, [$field_value]);
	}

	my $queryfielddefs = $queryDef->GetQueryFieldDefs(); 

	my $resultSet;
	eval {$resultSet = $lopts{session}->BuildResultSet($queryDef)};
	# Write to log file
	if ($@) {
		$logger->log_print_error(__LINE__ . ":  Building Query Failed: $@"); 
		return undef;
	}
	else {
		#$logger->log_print_message(" Generating query results from database");
		1;
	}

	my %results;

	my $ct = $resultSet->ExecuteAndCountRecords(); 
	# Find the first record within ClearQuest
	return undef if ($ct == 0);

	OUTER: for (my $i = 0; $i < $ct; $i++){
	$resultSet->MoveNext;
		for (my $i = 1; $i <= $resultSet->GetNumberOfColumns(); $i++) {
			my $name = $resultSet->GetColumnLabel($i);
			#my $type = $resultSet->GetColumnType($i);
			my $value = $resultSet->GetColumnValue($i);
			$self->{$name}{$value}++;
			last OUTER if $opts{top};
			
		}
	}
	#CQPerlExt::CQSession_Unbuild($lopts{session});
	1;
}	

# Always returns an array - TODO should add "wantarray"
sub get {
	my $self = shift;
	my $what = shift;
	my @values;
	#TODO "Tie" this
	if (exists $self->{$what}) {
		if (ref $self->{$what} eq "HASH") {
			for my $k (keys %{$self->{$what}}){
				push @values, $k;
			}
		}
		elsif( ref $self->{$what} eq "ARRAY"){
			for my $k (@{$self->{$what}}) {
				push @values, $k;
			}
		}
		else {
			push @values,$self->{$what};
		}
		return @values;
	}
	else {
		return undef;
	}
} 

1;
